<?php
/*
 * osCommerce, Open Source E-Commerce Solutions
 * http://www.oscommerce.com
 *
 * Copyright (c) 2009 osCommerce
 *
 * Released under the GNU General Public License
 *
 * Author: Ira Miller BTCinch LLC
*/
  require_once(DIR_FS_CATALOG.'BTCinch_PHP_SCI_lib/btcinch_config.php');
  require_once(DIR_FS_CATALOG.'BTCinch_PHP_SCI_lib/btcinch_sci.php');

  class btcinch {
    var $code, $title, $description, $enabled;

    function btcinch() {
      global $order;

      $this->code = 'btcinch';
      $this->title = MODULE_PAYMENT_BTCINCH_TEXT_TITLE;
      $this->public_title = MODULE_PAYMENT_BTCINCH_TEXT_PUBLIC_TITLE;
      $this->description = MODULE_PAYMENT_BTCINCH_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_BTCINCH_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_BTCINCH_STATUS == 'True') ? true : false);
      $this->api_version = '0.92';

      if ((int)MODULE_PAYMENT_BTCINCH_VERIFIED_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_BTCINCH_VERIFIED_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    }

    function update_status() {
        return false;
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      global $HTTP_GET_VARS, $order, $btcinch_token;

      /*if (!tep_session_is_registered('btcinch_token')) {
        tep_redirect(tep_href_link('btcinch-handler.php', '', 'SSL'));
      }*/

      if (!isset($HTTP_GET_VARS['do'])) {
        //Get transaction status.
        $response = getCheckoutDetails(MODULE_PAYMENT_BTCINCH_KEY,
                                       MODULE_PAYMENT_BTCINCH_PASS,
                                       $btcinch_token);
        if ($response->ACK == 'SUCCESS' || $response->ACK == 'VERIFIED') {
          include(DIR_WS_CLASSES . 'order_total.php');
          $order_total_modules = new order_total;
          $order_total_modules->process();

          //Verify that sufficient payment was sent.
          if ($response->TOTAL >= $this->format_raw($order->info['total'])) {
            tep_redirect(tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL'));
          } else {
            tep_redirect(tep_href_link(FILENAME_SHOPPING_CART, 'error_message=BTCinch: Insufficient amount sent: '.$response->TOTAL.' expected: '.$this->format_raw($order->info['total']).'  ' . stripslashes($response->ERRORMESSAGE), 'SSL'));;
          }
        } elseif($response->ACK == 'PENDING') {
          include(DIR_WS_CLASSES . 'order_total.php');
          $order_total_modules = new order_total;
          $order_total_modules->process();

          tep_redirect(tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL'));
        }
      }
    }

    function confirmation() {
      return false;
    }

    function process_button() {
        return "<input type='image' src='https://www.btcinch.com/wp-includes/images/btcinch-checkout.png' width='150' alt='Checkout'>";
    }

    function before_process() {
      global $customer_id, $order, $HTTP_POST_VARS, $btcinch_token;

      if (!tep_session_is_registered('btcinch_token')) {
        //Set transaction details for later use.
        $params = array('TOTAL' => $this->format_raw($order->info['total']),
                        'CURRENCYCODE' => $order->info['currency']);
        $response = setCheckoutDetails(MODULE_PAYMENT_BTCINCH_KEY,
                                       MODULE_PAYMENT_BTCINCH_PASS,
                                       0,
                                       $total = $this->format_raw($order->info['total']),
                                       $currencycode = $order->info['currency'],
                                       $return_url = tep_href_link('btcinch-handler.php', 'osC_Action=callback'),
                                       $cancel_url = tep_href_link('btcinch-handler.php', 'osC_Action=cancel'),
                                       $type = "ANY");

        //If successful, send user to payment gateway.
        if($response->ACK == 'PREPARED') {
          tep_session_register('btcinch_token');
          $btcinch_token = $response->TOKEN;
          tep_redirect("https://www.btcinch.com/paybtc/?token=".rawurlencode($btcinch_token)."&action=checkout");
        } else {
            //Transaction failed. Clean up, and start over.
            tep_session_unregister('btcinch_token');
            tep_redirect(tep_href_link(FILENAME_SHOPPING_CART, 'error_message=BTCinch: ' . stripslashes($response->ERRORMESSAGE), 'SSL'));
        }
      }
    }

    function after_process() {
        global $customer_id, $order, $btcinch_token, $order;

        //Get transaction results from BTCinch.
        $response = getCheckoutDetails(MODULE_PAYMENT_BTCINCH_KEY,
                                       MODULE_PAYMENT_BTCINCH_PASS,
                                       $btcinch_token);

        //If transaction was unsuccessful, redirect user to the shopping cart.
        if ($response->ACK != 'VERIFIED' && $response->ACK != 'SUCCESS' && $response->ACK != 'PENDING') {
            tep_session_unregister('btcinch_token');
            tep_redirect(tep_href_link(FILENAME_SHOPPING_CART, 'error_message=Server did not accept payment.', 'SSL'));
        }
        //If transaction was malformed, redirect user to the shopping cart. In this case, malformed means PENDING status but no Bitcoin address.
        if($response->ACK == 'PENDING' && empty($response->ADDRESS)) {
            tep_session_unregister('btcinch_token');
            tep_redirect(tep_href_link(FILENAME_SHOPPING_CART, 'error_message=Server did not accept payment.', 'SSL'));
        }

        //Get internal order ID.
        $oq = tep_db_query("SELECT orders_id FROM ".TABLE_ORDERS." WHERE customers_id='".$customer_id."' ORDER BY date_purchased DESC LIMIT 1");
        $orders = tep_db_fetch_array($oq);
        $order_id = $orders['orders_id'];

        if(empty($order_id)) {
            tep_redirect(tep_href_link(FILENAME_SHOPPING_CART, 'error_message=Could not find order.', 'SSL'));
        }

        //Print payment status and Bitcoin address in order comments.
        $result = "Payment Status: " . tep_output_string_protected($response->ACK) . ". ";

        $sql_data_array = array('orders_id' => $order_id, 
                                'date_added' => 'now()', 
                                'customer_notified' => '0',
                                'comments' => $result);

        if($response->ACK == 'PENDING') {
            $sql_data_array['comments'] .= "Your order has been successfully processed, but is not yet complete. To complete your order, send ".$response->TOTAL."BTC to the address below. You may also see the address in your <a href='" . tep_href_link(FILENAME_ACCOUNT_HISTORY, '', 'SSL') . "'>History</a>.<br><br>Bitcoin Address:".$response->ADDRESS;
            $sql_data_array['orders_status_id'] = 1;
            $sql_data_array['customer_notified'] = 1;

            //Email customer their bitcoin payment address.
            $email_order = "Your Bitcoin payment address for order #".$order_id." is: ".$response->ADDRESS.". Please send ".$response->TOTAL."BTC to the aforementioned address. After BTCinch confirms the funds, your order will be completed. This process may take anywhere from 30 to 90 minutes.";
            tep_mail($order->customer['firstname'] . ' ' . $order->customer['lastname'], $order->customer['email_address'], "BTCinch Payment Address", $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
        } else {
            $sql_data_array['orders_status_id'] = MODULE_PAYMENT_BTCINCH_VERIFIED_STATUS_ID;
        }

        //Update order history and status.
        tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
        tep_db_query("UPDATE ".TABLE_ORDERS." SET orders_status=".$sql_data_array['orders_status_id']." WHERE orders_id=".$order_id);

        //Send final Order ID to BTCinch. (required for payment status updates)
        updateOID(MODULE_PAYMENT_BTCINCH_KEY,
                  MODULE_PAYMENT_BTCINCH_PASS,
                  $order_id, $btcinch_token);

        tep_session_unregister('btcinch_token');
    }

    function output_error() {
        return false;
    }

    function check() {
        if (!isset($this->check)) {
            $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_BTCINCH_STATUS'");
            $this->check = tep_db_num_rows($check_query);
        }
        return $this->check;
    }

    function install() {
        //Check for Bitcoin currency.
        $query = tep_db_query("select currencies_id from " . TABLE_CURRENCIES . " where code='BTC' limit 1");

        //If Bitcoin is not installed, do so.
        if (tep_db_num_rows($query) < 1) {
            tep_db_query("INSERT INTO ".TABLE_CURRENCIES." (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `value`, `last_updated`) VALUES (NULL, 'Bitcoin', 'BTC', NULL, 'BTC', '.', '', '3', '0.33', NULL)");
        }

        //Create 'Verified' order status, for verified payments.
        $check_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Verified' limit 1");

        if (tep_db_num_rows($check_query) < 1) {
            $status_query = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
            $status = tep_db_fetch_array($status_query);

            $status_id = $status['status_id']+1;
            tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . 1 . "', 'Verified')");
        } else {
            $check = tep_db_fetch_array($check_query);

            $status_id = $check['orders_status_id'];
        }

        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Bitcoin Module', 'MODULE_PAYMENT_BTCINCH_STATUS', 'True', 'Do you want to accept Bitcoin payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('E-Mail Address', 'MODULE_PAYMENT_BTCINCH_ID', 'you@yourdomain.com', 'The e-mail address of your account with BTCinch', '6', '4', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_BTCINCH_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Verified Payment Order Status', 'MODULE_PAYMENT_BTCINCH_VERIFIED_STATUS_ID', '0', 'Set the status of orders with verified payment to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('BTCinch Key', 'MODULE_PAYMENT_BTCINCH_KEY', '1', 'BTCinch Merchant API Key', '6', '0', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('BTCinch Pass', 'MODULE_PAYMENT_BTCINCH_PASS', '0', 'BTCinch Merchant API Password', '6', '0', now())");
    }

    function remove() {
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_BTCINCH_STATUS', 'MODULE_PAYMENT_BTCINCH_VERIFIED_STATUS_ID', 'MODULE_PAYMENT_BTCINCH_ID', 'MODULE_PAYMENT_BTCINCH_KEY', 'MODULE_PAYMENT_BTCINCH_PASS', 'MODULE_PAYMENT_BTCINCH_SORT_ORDER');
    }

    /**
     * Format amount based on currency and conversion rate.
     */
    function format_raw($number, $currency_code = '', $currency_value = '') {
      global $currencies, $currency;

      if (empty($currency_code) || !$currencies->is_set($currency_code)) {
        $currency_code = $currency;
      }

      if (empty($currency_value) || !is_numeric($currency_value)) {
        $currency_value = $currencies->currencies[$currency_code]['value'];
      }
      return number_format(tep_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
    }
  }
?>
